using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Model.RequestParams;
using VkNet.Model.Keyboard;
using System.Collections.ObjectModel;
using System.Security.Cryptography;
using VkNet.Enums.SafetyEnums;
using SvetoforVKBot.Models.Dop;
using System.Linq;

namespace SvetoforVKBot.Models.Commands.Registration
{
    public class GetAgeCommand
    {
        public bool Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            MessagesSendParams @params = new MessagesSendParams();
            var chatId = update.@object.message.from_id;
            int i = 0;
            var keyboardBuilder = new KeyboardBuilder().Clear();

            try
            {
                if (update.@object.message.text.Length > 0 && update.@object.message.text.Length <= 2)
                {
                    // Согласовать по аттрибудам. Возможно привязан аттрибут к другому
                   
                    var user = db.Users.Single(usr => usr.chatId == chatId);
                    Int32.TryParse(update.@object.message.text.Trim(), out int age);
                    user.birthday = DateTime.Today.AddYears(-1*age);
                    user.tag = "Регистрация - Деятельность";
                    db.SaveChanges();

                    //ТОчно так надо??
                    //ShowActivity showActivity = new ShowActivity();
                    //showActivity.Execute(update, client, db);
                }
                else
                {
                    @params.UserId = chatId;
                    @params.Message = "Вы некорректно ввели возраст 🤔 Введите, пожалуйста, текст (до 2 символов).";
                    @params.RandomId = GetRandomId();
                    client.Messages.SendAsync(@params);
                }
            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в GetAgeCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
                return true;
            }
            return true;
        }

        private static readonly RandomNumberGenerator Rng = RandomNumberGenerator.Create();
        public int GetRandomId()
        {

            var intBytes = new byte[4];

            Rng.GetBytes(intBytes);

            return BitConverter.ToInt32(intBytes, 0);

        }
    }
}